﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace P4_1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        spriteComp gameObject1, gameObject2;
        Texture2D texture;
        Rectangle scrBounds;
        float sprSpeed;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            Services.AddService(typeof(SpriteBatch), spriteBatch);
            texture = Content.Load<Texture2D>("BallandBats");
            scrBounds = new Rectangle(0, 0,
                this.Window.ClientBounds.Width,
                this.Window.ClientBounds.Height);
            sprSpeed = 5;
            CreateNewObject();
            // TODO: use this.Content to load your game content here
        }

        protected void CreateNewObject()
        {
            gameObject1 = new spriteComp(this, ref texture,
                new Rectangle(18, 9, 17, 88),
                new Vector2(100, 150));
            Components.Add(gameObject1);
            gameObject2 = new spriteComp(this, ref texture,
                new Rectangle(17, 106, 17, 88),
                new Vector2(200, 150));
            Components.Add(gameObject2);
        }

        void Test(spriteComp spr, Rectangle scr)
        {
            if (spr.sprPosition.X < scr.Left)
            {
                spr.sprPosition.X = scr.Left;
            }
            if (spr.sprPosition.X > scr.Width - spr.sprRectangle.Width)
            {
                spr.sprPosition.X = scr.Width - spr.sprRectangle.Width;
            }
            if (spr.sprPosition.Y < scr.Top)
            {
                spr.sprPosition.Y = scr.Top;
            }
            if (spr.sprPosition.Y > scr.Height - spr.sprRectangle.Height)
            {
                spr.sprPosition.Y = scr.Height - spr.sprRectangle.Height;
            }
        }
        void MoveUp(spriteComp spr, float speed)
        {
            spr.sprPosition.Y -= speed ;
        }
        void MoveDown(spriteComp spr,float speed)
        {
            spr.sprPosition.Y += speed;
        }
        void MoveLeft(spriteComp spr, float speed)
        {
            spr.sprPosition.X -= speed ;
        }
        void MoveRight(spriteComp spr, float speed)
        {
            spr.sprPosition.X += speed ;
        }
        bool  IsCollide(spriteComp sp1, spriteComp sp2)
        {
            if (sp1.sprPosition.X < sp2.sprPosition.X + sp2.sprRectangle.Width &&
                sp1.sprPosition.X + sp1.sprRectangle.Width > sp2.sprPosition.X &&
                sp1.sprPosition.Y < sp2.sprPosition.Y + sp2.sprRectangle.Height &&
                sp1.sprPosition.Y + sp1.sprRectangle.Height > sp2.sprPosition.Y)
            {
                return true;
            }
            else return false;

        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // TODO: Add your update logic here
            KeyboardState kbState = Keyboard.GetState();
            if (kbState.IsKeyDown(Keys.Up))
            {
                MoveUp(gameObject1, sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveDown(gameObject1, (sprSpeed / 10));
                }
            }
            if (kbState.IsKeyDown(Keys.Down))
            {
                MoveDown(gameObject1, sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveUp(gameObject1, (sprSpeed / 10));
                }
            }
            if (kbState.IsKeyDown(Keys.Left))
            {
                MoveLeft(gameObject1, sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveRight(gameObject1, (sprSpeed / 10));
                }
            }
            if (kbState.IsKeyDown(Keys.Right))
            {
                MoveRight(gameObject1,sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveLeft(gameObject1, (sprSpeed / 10));
                }
            }
            Test(gameObject1, scrBounds);
            if (kbState.IsKeyDown(Keys.W))
            {
                MoveUp(gameObject2,sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveDown(gameObject2, (sprSpeed / 10));
                }
            }
            if (kbState.IsKeyDown(Keys.S))
            {
                MoveDown(gameObject2,sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveUp(gameObject2, (sprSpeed / 10));
                }
            }
            if (kbState.IsKeyDown(Keys.A))
            {
                MoveLeft(gameObject2,sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveRight(gameObject2, (sprSpeed / 10));
                }
            }
            if (kbState.IsKeyDown(Keys.D))
            {
                MoveRight(gameObject2,sprSpeed );
                while (IsCollide(gameObject1, gameObject2))
                {
                    MoveLeft(gameObject2, (sprSpeed / 10));
                }
            }
            Test(gameObject2, scrBounds);
            
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            spriteBatch.Begin();
            base.Draw(gameTime);
            spriteBatch.End();
        }
    }
}